//IIC Software Solution Library
//This library is designed for the software solution of IIC
//Date:2016.8.1
//Developer:Tifer King
//Thanks LiWM, help me in debugging, and fixed many errors.
//Thank you.
//And thank you for your use.
//Anything? Contect me at www.tiferking.cn
#ifndef IIC
#define IIC

#include <msp430.h>
//Header file which include MCU's register definition

#ifndef IIC_CONF
#define IIC_CONF
//If you have configured IIC at another place before this
//then this default configuration will not be defined.

#define IIC_Data_OUT	P1OUT		//Output register name used by IIC
#define IIC_Data_IN		P1IN		//Input register name used by IIC
#define IIC_Data_DIR	P1DIR		//Direction register name used by IIC
#define IIC_SCL_BIT		BIT6		//SCL Port
#define IIC_SDA_BIT		BIT7		//SDA Port
#define IIC_Delay		10			//IIC bit transfer hold delay

#endif // IIC_CONF

#define SDA_OUT			IIC_Data_DIR |= IIC_SDA_BIT						//Set SDA in output mode
#define SDA_IN			IIC_Data_DIR &=~ IIC_SDA_BIT					//Set SDA in input mode

#define SDA_H			IIC_Data_OUT |= IIC_SDA_BIT						//Set SDA high
#define SDA_L			IIC_Data_OUT &=~ IIC_SDA_BIT					//Set SDA low
#define SCL_H			IIC_Data_OUT |= IIC_SCL_BIT						//Set SCL high
#define SCL_L			IIC_Data_OUT &=~ IIC_SCL_BIT					//Set SCL low
#define SDA_I			((IIC_Data_IN & IIC_SDA_BIT) == 0 ? 0x00 : 0x01)//Get SDA input bit

#define EMPTY 			0x00
//When function input pointer is unnecessary,
//use pointer = EMPTY and number = 0 to use it.

////////////////////////////////////////////////////
//Function name:IIC_Write
//Description:Input the device's physical address,
//command in write and write in data with three
//unsigned char const pointer and followed by a
//number which mean the length of the string. Then
//IIC bus will work immediately to send all the data,
//function will return when data transfer done.
////////////////////////////////////////////////////
extern void IIC_Write(unsigned char const dev_add,unsigned char const *write_cmd,unsigned char const cmd_size,unsigned char const *data,unsigned char const data_size);

////////////////////////////////////////////////////
//Function name:IIC_Read
//Description:Input the device's physical address,
//command in read and input data buffer with three
//unsigned char const pointer and followed by a
//number which mean the length of the string. Then
//IIC bus will work immediately to send the command
//data, and then waiting for data incoming,
//function will return when enought data read, and
//the data will be save in the place where *data
//reffered.
////////////////////////////////////////////////////
extern void IIC_Read(unsigned char const dev_add,unsigned char const *read_cmd,unsigned char const cmd_size,unsigned char *data,unsigned char const data_size);

#endif // IIC
